package yrpg.fi.cas.plugin.operate;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.exception.KDBizException;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.sdk.plugin.Plugin;

/**
 * 单据操作插件  付款处理单  失败重付操作
 */
public class CheckBeforeFailrePaymentOpPlugin extends AbstractOperationServicePlugIn implements Plugin {

    public void onPreparePropertys(PreparePropertysEventArgs e){
        e.getFieldKeys().add("billstatus");
        e.getFieldKeys().add("yrpg_paystatus");
    }

    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);

        DynamicObject[] bills = e.getDataEntities();
        for(DynamicObject bill:bills){
            //支付状态为支付失败、退票的付款处理单
            if(!"3".equals(bill.getString("yrpg_paystatus"))&&!"5".equals(bill.getString("yrpg_paystatus"))){
                throw new KDBizException("当前支付状态不为支付失败/退票，不可以进行失败重付操作");
            }
        }
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);

        DynamicObject[] bills = e.getDataEntities();
        //单据状态更新为已审核，支付状态为8-重付待推送
        for(DynamicObject bill:bills){
            bill.set("billstatus","C");
            bill.set("yrpg_paystatus","8");
        }

        SaveServiceHelper.update(bills);
    }
}